/** @file ccp_main.cpp
 *
 * Available scenarios for verifying the cache coherence protocol.
 * They differ by state abstraction techniques being used.
 *
 * @author Alexander Kamkin (kamkin@ispras.ru)
 */

#include <utils/testreg.h>

#include <moesi_scenario.hpp>

using namespace cpptesk::examples::moesi;

MoesiScenario test;

#define TEST_OPTS "-nt -tf2 trace.utt2 -uerr=1 --nondeterministic --print-progress"

TEST_REGISTRY_BEGIN
    REGISTER_TEST(test, engine::fsm, TEST_OPTS)
TEST_REGISTRY_END

int main()
{
    return startScenario_TestRegistry("test", LOCAL);
}

