/*
 * Generated by veritool: Copyright (c) 2009-2011 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

`timescale 1 ns/1 ps
`include "tests/src/sverilog/counter.sv" // --------- was added manually

module testbench();

    // --------- begining of another manually inserted block
    import "DPI" function init_state(input string state);
    import "DPI" function take_inputs(output InputSignals inputSignals, output Requests requests);
    import "DPI" function send_outputs(input OutputSignals outputSignals, input Requests requests);

    InputSignals inputSignals;
    OutputSignals outputSignals;
    Requests requests;
    string state;
    Counter refdesign;

    /* Example of C++ calling SystemVerilog; this call may be only a callback
    export "DPI" function exported_sv_function;
    function exported_sv_function();
    begin
        $display("hello!");
        $display(refdesign.state());
    end
    endfunction

    // Part of C++ code:
    extern "C" { extern void exported_sv_function(); }
    */
    // --------- ending of the block

    parameter HALF_CYCLE_DELAY = 5;
    parameter RESET_CYCLE_NUMBER = 3;
    parameter INC_CYCLE_ACCORD_TO_FRONT_OF_CLK = 1;

    reg clk;
    reg inc;
    reg inc_reg;
    reg rst;
    reg run;
    wire [7:0] data;

// --------- inserted - begin
`include "tests/src/sverilog/coverages.sv"
// --------- inserted - end

    always @(posedge clk) begin
        inc_reg <= inc;
    end

    count target (
        .clk(clk),
        .inc(inc_reg),
        .rst(rst),
        .data(data)
    );

    reg [63 : 0] CYCLE;
    reg [256 * 8 : 1] argv;
    reg [64 * 8 : 1] pstring;
    reg [64 * 8 : 1] dumpfilename;
    reg netscen;

    task cycle;
    input inc_CYCLE;
    begin
        clk = 0; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 1) CYCLE = CYCLE + 1;
        clk = 1; #(HALF_CYCLE_DELAY);
        if(inc_CYCLE == 1 && INC_CYCLE_ACCORD_TO_FRONT_OF_CLK == 0) CYCLE = CYCLE + 1;
    end
    endtask

    task delay;
    input inc_CYCLE;
    input [31:0] number_of_cycles;
    reg [31:0] i;
    begin
        i = 0;
        while(i < number_of_cycles)
        begin
            cycle(inc_CYCLE);
            i = i + 1;
        end
    end
    endtask

    initial begin
        if(!$value$plusargs("dumpfile=%s", dumpfilename)) begin
            dumpfilename="testbench.vcd";
        end
        if(!$test$plusargs("nodumpfile")) begin
            $dumpfile(dumpfilename);
            $dumpvars(1, testbench);
        end
        clk = 1'h0;
        inc = 1'h0;
        rst = 1'h0;
        CYCLE = 0;
        rst = 1'h1;
        delay(0, RESET_CYCLE_NUMBER);

        rst = 1'h0;

// --------- inserted - begin
        refdesign = new();
        counter_coverage = new();
// --------- inserted - end

        if($test$plusargs("netscen"))
            netscen = 1;
        else
            netscen = 0;

        argv = 0;
        if($value$plusargs("argv=%s", argv)) begin
        end

        if($value$plusargs("scen=%s", pstring)) begin
// --------- inserted - begin
            init_state(refdesign.state);
// --------- inserted - end

            $setScenario(netscen, argv, pstring);
            run = 1'h1;
        end
        else begin
            $display("Please, type a scenario name with +scen=SCEN_NAME parameter");
            run = 1'h0;
        end

        while(run) begin
// --------- inserted - begin
            take_inputs(inputSignals, requests);
            refdesign.recognizeOperations(inputSignals, requests);
            refdesign.cycle();
            refdesign.getResults(outputSignals, requests);
            send_outputs(outputSignals, requests);
            init_state(refdesign.state);
// --------- inserted - end

            cycle(1);
            $callts();
        end
        cycle(1);
    end
endmodule
